VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSmartForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private poForm As Object 'Underlying form object
Private poContainer As Object 'container within form, optional
Private poForms As Object 'form collection, if used, refers to client app's forms collection

Public Property Get FormObject() As Object
    Set FormObject = poForm
End Property

Public Property Set FormObject(ByVal NewValue As Object)
    Set poForm = NewValue
End Property
Public Sub UnloadAllExceptMe(Optional FormCollection As Object)
On Error Resume Next

Dim oForm As Object

If FormCollection Is Nothing Then Set FormCollection = poForms
If FormCollection Is Nothing Then Exit Sub

Dim i As Integer

For Each oForm In FormCollection
    
    If oForm.Name <> poForm.Name Then
       
        If Not (TypeOf oForm Is MDIForm) Then Unload oForm
    End If
Next
End Sub
Public Sub UnloadAllExceptOne(FormObject As Object, Optional FormCollection As Object)
On Error Resume Next

Dim oForm As Object, oForms As Object

If FormCollection Is Nothing Then Set FormCollection = poForms
If FormCollection Is Nothing Then Exit Sub

For Each oForm In oForms
    
    If oForm.Name <> FormObject.Name Then
       
            If Not (TypeOf oForm Is MDIForm) Then Unload oForm
       
    
        Unload oForm
    End If

Next
End Sub

Public Sub HideAllExceptMe(Optional FormCollection As Object)
On Error Resume Next


Dim oForm As Object
If FormCollection Is Nothing Then Set FormCollection = poForms
If FormCollection Is Nothing Then Exit Sub

For Each oForm In FormCollection

    If oForm.Name <> poForm.Name Then
       
            If Not (TypeOf oForm Is MDIForm) Then oForm.Hide
      
    End If
Next
End Sub

Public Sub HideAllExceptOne(FormObject As Object, Optional FormCollection As Object)
On Error Resume Next
Dim oForm As Object, oForms As Object

If FormCollection Is Nothing Then Set FormCollection = poForms
If FormCollection Is Nothing Then Exit Sub

For Each oForm In oForms
    If oForm.Name <> FormObject.Name Then
        If Not (TypeOf oForm Is MDIForm) Then oForm.Hide
    End If
Next
End Sub

Public Sub Initialize(FormCollection As Object, FormObject As Object, Optional ContainerObject As Object)

Set poForms = FormCollection
Set poForm = FormObject
If Not ContainerObject Is Nothing Then Set poContainer = ContainerObject
CenterForm


End Sub
Public Sub CenterForm(Optional FormObject As Object)
    On Error Resume Next
    If FormObject Is Nothing Then Set FormObject = poForm
    FormObject.Move (Screen.Width - FormObject.Width) / 2, (Screen.Height - FormObject.Height) / 2

End Sub

Public Sub CenterContainerHorizontal()

On Error Resume Next
Dim sngParentWidth As Single

If poForm Is Nothing Or poContainer Is Nothing Then Exit Sub

Err.Clear

sngParentWidth = poForm.ScaleWidth
If Err.Number > 0 Then sngParentWidth = poForm.Width


If sngParentWidth > 0 Then poContainer.Left = (sngParentWidth - poContainer.Width) / 2

End Sub

Public Sub CenterContainerVertical()

On Error Resume Next

Dim sngParentHeight As Single


If poForm Is Nothing Or poContainer Is Nothing Then Exit Sub

Err.Clear
sngParentHeight = poForm.ScaleHeight
If Err.Number > 0 Then sngParentHeight = poForm.Height
If sngParentHeight > 0 Then poContainer.Top = (sngParentHeight - poContainer.Height) / 2
End Sub

Public Sub CenterContainer()
    On Error Resume Next
    CenterContainerHorizontal
    CenterContainerVertical
End Sub
Public Property Set Container(ByVal NewValue As Object)
    Set poContainer = NewValue
End Property
Public Property Get Container()
    Set Container = poContainer
End Property
Public Sub AlignControlsLeft(StandardizeWidth As Boolean, base As Object, ParamArray cnts())
On Error Resume Next
Dim i As Integer
    For i = 0 To UBound(cnts)
        cnts(i).Left = base.Left
        If StandardizeWidth Then cnts(i).Width = base.Width
    Next
End Sub

Public Sub AlignControlsTop(StandardizeHeight As Boolean, base As Object, ParamArray cnts())
On Error Resume Next
Dim i As Integer
For i = 0 To UBound(cnts)
cnts(i).Top = base.Top
If StandardizeHeight Then cnts(i).Height = base.Height
Next
End Sub
Public Sub CenterControlHorizontal(child As Object)
On Error Resume Next

Dim sngParentWidth As Single
Dim oParent As Object

Set oParent = IIf(poContainer Is Nothing, poForm, poContainer)
If oParent Is Nothing Then Exit Sub

Err.Clear
sngParentWidth = oParent.ScaleWidth

If Err.Number > 0 Then sngParentWidth = oParent.Width

If sngParentWidth > 0 Then child.Left = (sngParentWidth - child.Width) / 2
End Sub
Public Sub CenterControlVertical(child As Object)
On Error Resume Next

Dim sngParentHeight As Single
Dim oParent As Object

Set oParent = IIf(poContainer Is Nothing, poForm, poContainer)
If oParent Is Nothing Then Exit Sub
Err.Clear

sngParentHeight = oParent.ScaleHeight
If Err.Number > 0 Then sngParentHeight = oParent.Height
If sngParentHeight > 0 Then child.Top = (sngParentHeight - child.Height) / 2

End Sub
Public Sub CenterControl(child As Object)
On Error Resume Next
    CenterControlHorizontal child
    CenterControlVertical child
End Sub
Public Sub CenterControlsHorizontal(space As Single, AlignTop As Boolean, ParamArray cnts())
Dim sngTotalSpace As Single
Dim i As Integer
Dim oParent As Object
Dim sngBaseTop As Single
Dim sngParentWidth As Single

On Error Resume Next

Set oParent = IIf(poContainer Is Nothing, poForm, poContainer)
If oParent Is Nothing Then Exit Sub

'WARNING: This won't work right if oParent is a container within a form, and the form's
'scalemode <> vbTwips, and container doesn't support scalemode property



Err.Clear
sngParentWidth = oParent.ScaleWidth
If Err.Number > 0 Then sngParentWidth = oParent.Width




For i = 0 To UBound(cnts)
    sngTotalSpace = sngTotalSpace + cnts(i).Width
Next

sngTotalSpace = sngTotalSpace + (space * (UBound(cnts)))

cnts(0).Left = (sngParentWidth - sngTotalSpace) / 2
sngBaseTop = cnts(0).Top

For i = 1 To UBound(cnts)
    cnts(i).Left = cnts(i - 1).Left + cnts(i - 1).Width + space
    If AlignTop Then cnts(i).Top = sngBaseTop
Next

End Sub
Public Sub CenterControlsVertical(space As Single, AlignLeft As Boolean, ParamArray cnts())
Dim sngTotalSpace As Single
Dim i As Integer
Dim sngBaseLeft As Single

Dim oParent As Object

On Error Resume Next
Dim sngParentHeight As Single

Set oParent = IIf(poContainer Is Nothing, poForm, poContainer)
If oParent Is Nothing Then Exit Sub

'WARNING: This won't work right if oParent is a container within a form, and the form's
'scalemode <> vbTwips, and container doesn't support scalemode property


Err.Clear
sngParentHeight = oParent.ScaleHeight
If Err.Number > 0 Then sngParentHeight = oParent.Height

       
    

For i = 0 To UBound(cnts)
    sngTotalSpace = sngTotalSpace + cnts(i).Height
Next

sngTotalSpace = sngTotalSpace + (space * (UBound(cnts)))
cnts(0).Top = (sngParentHeight - sngTotalSpace) / 2


sngBaseLeft = cnts(0).Left

For i = 1 To UBound(cnts)
    cnts(i).Top = cnts(i - 1).Top + cnts(i - 1).Height + space
    If AlignLeft Then cnts(i).Left = sngBaseLeft
Next
End Sub

Public Sub CenterControls(space As Single, AlignTop As Boolean, AlignLeft As Boolean, ParamArray cnts())
'paramarray doesn't go from one function to another
'so have to repeat centerhorizontal and centervertical
Dim oParent As Object
Dim sngTotalSpace As Single
Dim i As Integer
Dim sngBaseLeft As Single, sngBaseTop As Single
Dim sngParentHeight As Single, sngParentWidth As Single



On Error Resume Next

Set oParent = IIf(poContainer Is Nothing, poForm, poContainer)
If oParent Is Nothing Then Exit Sub

Err.Clear
sngParentHeight = oParent.ScaleHeight
If Err.Number > 0 Then sngParentHeight = oParent.Height

Err.Clear
sngParentWidth = oParent.ScaleWidth
If Err.Number > 0 Then sngParentWidth = oParent.Width



If AlignLeft Then
    sngTotalSpace = cnts(0).Width
Else
    For i = 0 To UBound(cnts)
        sngTotalSpace = sngTotalSpace + cnts(i).Width
    Next
    sngTotalSpace = sngTotalSpace + (space * (UBound(cnts)))
End If

cnts(0).Left = (sngParentWidth - sngTotalSpace) / 2
sngBaseLeft = cnts(0).Left
'if align left, just do the first one and align the rest

For i = 1 To UBound(cnts)
    
    If AlignLeft Then
        cnts(i).Left = sngBaseLeft
    Else
        cnts(i).Left = cnts(i - 1).Left + cnts(i - 1).Width + space
    End If
Next

'vertical
sngTotalSpace = 0
If AlignTop Then
    sngTotalSpace = cnts(0).Height
Else
    For i = 0 To UBound(cnts)
        sngTotalSpace = sngTotalSpace + cnts(i).Height
    Next
End If
sngTotalSpace = sngTotalSpace + (space * (UBound(cnts)))

cnts(0).Top = (sngParentHeight - sngTotalSpace) / 2
sngBaseTop = cnts(0).Top
For i = 1 To UBound(cnts)
 cnts(i).Top = cnts(i - 1).Top + cnts(i - 1).Height + space
    
    If AlignTop Then cnts(i).Top = sngBaseTop

Next

End Sub


Public Sub SetVerticalDistance(distance As Single, StandardizeHeight As Boolean, AlignLeft As Boolean, ParamArray cnts())

On Error Resume Next
Dim i As Integer
Dim sngBaseHeight As Single, sngBaseLeft As Single

sngBaseHeight = cnts(0).Height
sngBaseLeft = cnts(0).Left
For i = 1 To UBound(cnts)
    If StandardizeHeight Then cnts(i).Height = sngBaseHeight
    If AlignLeft = True Then cnts(i).Left = sngBaseLeft
    cnts(i).Top = cnts(i - 1).Top + cnts(i - 1).Height + distance
   
Next

End Sub

Public Sub SetTabStops(start As Integer, ParamArray cnts())

On Error Resume Next

Dim i As Integer

Do
    cnts(i).TabIndex = start
    start = start + 1
    i = i + 1
    If i > UBound(cnts) Then Exit Do
Loop
End Sub

Public Sub SetHorizontalDistance(distance As Single, StandardizeWidth As Boolean, AlignTop As Boolean, ParamArray cnts())
On Error Resume Next
Dim i As Integer

For i = 1 To UBound(cnts)
    If StandardizeWidth Then cnts(i).Width = cnts(i - 1).Width
    cnts(i).Left = cnts(i - 1).Left + cnts(i - 1).Width + distance
    If AlignTop Then cnts(i).Top = cnts(i - 1).Top
Next
End Sub

Public Sub AlignControlsRight(base As Object, ParamArray cnts())
On Error Resume Next
Dim i As Integer
    For i = 0 To UBound(cnts)
        If cnts(i).Width <= base.Width Then
          
                cnts(i).Left = base.Left + (base.Width - cnts(i).Width)
            
       
        Else
          
                'cnts(i).Left = base.Left - (cnts(i).Width - base.Width)
                cnts(i).Left = (base.Left + base.Width) - cnts(i).Width
        End If
    Next
End Sub

Public Sub AlignControlsBottom(base As Object, ParamArray cnts())
Dim i As Integer

On Error Resume Next
For i = 0 To UBound(cnts)
    
    If cnts(i).Height <= base.Height Then
        cnts(i).Top = base.Top + (base.Height - cnts(i).Height)
        
    Else
        cnts(i).Top = base.Top - (cnts(i).Height - base.Height)
    End If
    
Next
End Sub

Public Sub CenterControlRelativeHorizontal(ctl As Object, RelativeTo As Object)
On Error Resume Next
ctl.Left = RelativeTo.Left + ((RelativeTo.Width - ctl.Width) / 2)

End Sub


Public Sub CenterControlRelativeVertical(ctl As Object, RelativeTo As Object)

On Error Resume Next
ctl.Top = RelativeTo.Top + ((RelativeTo.Height - ctl.Height) / 2)

End Sub


Public Property Set FormCollection(ByVal NewValue As Object)
    'Should be set to Forms Collection
    'can also be set via initialize method

Set poForms = NewValue
End Property
